package org.apache.commons.lang3.text;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.io.Reader;
import org.apache.commons.lang3.text.StrBuilder;

class StrBuilderReader extends Reader {
  private int pos;
  
  private int mark;
  
  public void close() {}
  
  public int read() {
    if (!ready())
      return -1; 
    return StrBuilder.this.charAt(this.pos++);
  }
  
  public int read(char[] b, int off, int len) {
    if (off < 0 || len < 0 || off > b.length || off + len > b.length || off + len < 0)
      throw new IndexOutOfBoundsException(); 
    if (len == 0)
      return 0; 
    if (this.pos >= StrBuilder.this.size())
      return -1; 
    if (this.pos + len > StrBuilder.this.size())
      len = StrBuilder.this.size() - this.pos; 
    StrBuilder.this.getChars(this.pos, this.pos + len, b, off);
    this.pos += len;
    return len;
  }
  
  public long skip(long n) {
    if (this.pos + n > StrBuilder.this.size())
      n = (StrBuilder.this.size() - this.pos); 
    if (n < 0L)
      return 0L; 
    this.pos = (int)(this.pos + n);
    return n;
  }
  
  public boolean ready() {
    return (this.pos < StrBuilder.this.size());
  }
  
  public boolean markSupported() {
    return true;
  }
  
  public void mark(int readAheadLimit) {
    this.mark = this.pos;
  }
  
  public void reset() {
    this.pos = this.mark;
  }
}
